using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.Text.RegularExpressions;
using System.Collections;
using System.Windows.Forms;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using PaintDotNet.Effects;
using PaintDotNet;

namespace TRsSplineMaster
{

    public class EffectPluginConfigDialog : PaintDotNet.Effects.EffectConfigDialog
    {
        private Button buttonOK;
        private Panel PreViewBMP;
        private Button cancelbutton;
        private bool saver = false;
        private Point premotion = new Point();
        private Point motion = new Point();
        private Point fixmotion = new Point();
        private Point PanBase = new Point();
        private Point[] Nodes = new Point[0];
        private Point[] cloneNodes = new Point[0];
        private Point Center = new Point();
        private Point FullCenter = new Point();
        private bool anchor = false;
        private int NodeSelect = -1;
        bool PanFlag = false;
        bool MoveFlag = false;
        private Rectangle MyBounds =  new Rectangle();
        private Bitmap OverlayBMP;
        private Bitmap CheckerBG;
        private int[] SECap = {
                                (int)LineCap.NoAnchor,
                                (int)LineCap.ArrowAnchor,
                                (int)LineCap.DiamondAnchor,
                                (int)LineCap.Flat,
                                (int)LineCap.Round,
                                (int)LineCap.RoundAnchor,
                                (int)LineCap.Square,
                                (int)LineCap.SquareAnchor,
                                (int)LineCap.Triangle
                                };

        private int[] DStyle = {
                                (int)DashStyle.Solid,
                                (int)DashStyle.Dash,
                                (int)DashStyle.DashDot,
                                (int)DashStyle.DashDotDot,
                                (int)DashStyle.Dot
                                };
        ArrayList Splines = new ArrayList();
        ArrayList cloneSplines = new ArrayList();

        private Panel instructions;
        private Label label7;
        private Label label6;
        private Label label5;
        private Label label4;
        private Panel PropertyPanel;
        private Label label1;
        private Label mwsNum;
        private CheckBox FilledBox;
        private CheckBox ClosedBox;
        private HScrollBar lineWidth;
        private CheckBox ShowHandles;
        private Label label3;
        private Label TenNum;
        private HScrollBar Tension;
        private CheckBox AntiAliasBox;
        private Button ApplyLines;
        private ColorDialog colorDialog1;
        private Panel ColorPanel;
        private CheckBox BGClear;
        private Label label11;
        private Label label10;
        private Panel SelectPanel;
        private Panel NodePanel;
        private Label label9;
        private Panel fillPanel;
        private Label label8;
        private Panel StylePanel;
        private ComboBox SCap;
        private ComboBox LStyle;
        private ComboBox ECap;
        private Label label17;
        private Label OPNum;
        private HScrollBar Opaque;
        private ListBox SplineList;
        private Button Reset;
        private Button Export;
        private Button Import;
        private OpenFileDialog openFileDialog1;
        private SaveFileDialog saveFileDialog1;
        private Label ApplyAll;
        private Label Remove;
        private TextBox SplineName;
        private Panel ListPanel;
        private Panel SpinePanel;
        private Panel ActionPanel;
        private Button ReDoButton;
        private Button Clone;
        private CheckBox ViewAll;
        private Panel XFormPanel;
        private Label label14;
        private Label label15;
        private Label label19;
        private Label label20;
        private Label label22;
        private Label label25;
        private Label label18;
        private Label label16;
        private Label label13;
        private Label label12;
        private PictureBox pictureBox1;
        private Label SaveXform;
        private CheckBox Xparent;
        private Label label21;
        //private IContainer components;
        private Label label2;

        public EffectPluginConfigDialog()
        {
            InitializeComponent();
        }

        protected override void InitialInitToken()
        {
            theEffectToken = new EffectPluginConfigToken(false,true,1,true,50,255,0,0,0,Color.Black,Color.Blue,Color.Red,Color.Cornsilk);
            
        }

        protected override void InitTokenFromDialog()
        {
            EffectPluginConfigToken token = (EffectPluginConfigToken)base.theEffectToken;
            token.Save = saver;
            token.ShowHandles = ShowHandles.Checked;
            token.lineWidth = lineWidth.Value;
            token.AntiAliasBox = AntiAliasBox.Checked;
            token.Tension = Tension.Value;
            token.Opaque = Opaque.Value;
            token.SCap = SCap.SelectedIndex;
            token.LStyle = LStyle.SelectedIndex;
            token.ECap = ECap.SelectedIndex;
            token.ColorPanel = ColorPanel.BackColor;
            token.SelectPanel = SelectPanel.BackColor;
            token.NodePanel = NodePanel.BackColor;
            token.fillPanel = fillPanel.BackColor;


        }

        protected override void InitDialogFromToken(EffectConfigToken effectToken)
        {
             EffectPluginConfigToken token = (EffectPluginConfigToken)effectToken;

             token.Save = false;
             saver = false;
             ShowHandles.Checked = token.ShowHandles;
             lineWidth.Value = token.lineWidth;
             AntiAliasBox.Checked = token.AntiAliasBox;
             Tension.Value = token.Tension;
             Opaque.Value = token.Opaque;
             SCap.SelectedIndex = token.SCap;
             LStyle.SelectedIndex = token.LStyle;
             ECap.SelectedIndex = token.ECap;
             ColorPanel.BackColor = token.ColorPanel;
             SelectPanel.BackColor = token.SelectPanel;
             NodePanel.BackColor = token.NodePanel;
             fillPanel.BackColor = token.fillPanel;

        }

        private void InitializeComponent()
        {
            this.buttonOK = new System.Windows.Forms.Button();
            this.PreViewBMP = new System.Windows.Forms.Panel();
            this.cancelbutton = new System.Windows.Forms.Button();
            this.instructions = new System.Windows.Forms.Panel();
            this.label18 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.ViewAll = new System.Windows.Forms.CheckBox();
            this.PropertyPanel = new System.Windows.Forms.Panel();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.SelectPanel = new System.Windows.Forms.Panel();
            this.NodePanel = new System.Windows.Forms.Panel();
            this.label9 = new System.Windows.Forms.Label();
            this.fillPanel = new System.Windows.Forms.Panel();
            this.label8 = new System.Windows.Forms.Label();
            this.ColorPanel = new System.Windows.Forms.Panel();
            this.label3 = new System.Windows.Forms.Label();
            this.label17 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.TenNum = new System.Windows.Forms.Label();
            this.OPNum = new System.Windows.Forms.Label();
            this.mwsNum = new System.Windows.Forms.Label();
            this.AntiAliasBox = new System.Windows.Forms.CheckBox();
            this.Xparent = new System.Windows.Forms.CheckBox();
            this.FilledBox = new System.Windows.Forms.CheckBox();
            this.Tension = new System.Windows.Forms.HScrollBar();
            this.Opaque = new System.Windows.Forms.HScrollBar();
            this.ClosedBox = new System.Windows.Forms.CheckBox();
            this.lineWidth = new System.Windows.Forms.HScrollBar();
            this.BGClear = new System.Windows.Forms.CheckBox();
            this.ShowHandles = new System.Windows.Forms.CheckBox();
            this.ApplyLines = new System.Windows.Forms.Button();
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.StylePanel = new System.Windows.Forms.Panel();
            this.SCap = new System.Windows.Forms.ComboBox();
            this.LStyle = new System.Windows.Forms.ComboBox();
            this.ECap = new System.Windows.Forms.ComboBox();
            this.SplineList = new System.Windows.Forms.ListBox();
            this.Reset = new System.Windows.Forms.Button();
            this.Export = new System.Windows.Forms.Button();
            this.Import = new System.Windows.Forms.Button();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.ApplyAll = new System.Windows.Forms.Label();
            this.Remove = new System.Windows.Forms.Label();
            this.SplineName = new System.Windows.Forms.TextBox();
            this.ListPanel = new System.Windows.Forms.Panel();
            this.SaveXform = new System.Windows.Forms.Label();
            this.SpinePanel = new System.Windows.Forms.Panel();
            this.Clone = new System.Windows.Forms.Button();
            this.ActionPanel = new System.Windows.Forms.Panel();
            this.ReDoButton = new System.Windows.Forms.Button();
            this.XFormPanel = new System.Windows.Forms.Panel();
            this.label14 = new System.Windows.Forms.Label();
            this.label15 = new System.Windows.Forms.Label();
            this.label19 = new System.Windows.Forms.Label();
            this.label20 = new System.Windows.Forms.Label();
            this.label22 = new System.Windows.Forms.Label();
            this.label25 = new System.Windows.Forms.Label();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.label21 = new System.Windows.Forms.Label();
            this.instructions.SuspendLayout();
            this.PropertyPanel.SuspendLayout();
            this.StylePanel.SuspendLayout();
            this.ListPanel.SuspendLayout();
            this.SpinePanel.SuspendLayout();
            this.ActionPanel.SuspendLayout();
            this.XFormPanel.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // buttonOK
            // 
            this.buttonOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.buttonOK.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.buttonOK.Location = new System.Drawing.Point(2, 67);
            this.buttonOK.Name = "buttonOK";
            this.buttonOK.Size = new System.Drawing.Size(95, 24);
            this.buttonOK.TabIndex = 2;
            this.buttonOK.Text = "OK";
            this.buttonOK.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            this.buttonOK.UseVisualStyleBackColor = true;
            this.buttonOK.Click += new System.EventHandler(this.savebutton_Click);
            // 
            // PreViewBMP
            // 
            this.PreViewBMP.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.PreViewBMP.BackColor = System.Drawing.Color.Black;
            this.PreViewBMP.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.PreViewBMP.Location = new System.Drawing.Point(7, 7);
            this.PreViewBMP.Name = "PreViewBMP";
            this.PreViewBMP.Size = new System.Drawing.Size(774, 424);
            this.PreViewBMP.TabIndex = 3;
            this.PreViewBMP.Tag = "";
            this.PreViewBMP.Click += new System.EventHandler(this.PreViewBMP_Click);
            this.PreViewBMP.Paint += new System.Windows.Forms.PaintEventHandler(this.PreViewBMP_Paint);
            this.PreViewBMP.MouseDown += new System.Windows.Forms.MouseEventHandler(this.PreViewBMP_MouseDown);
            this.PreViewBMP.MouseMove += new System.Windows.Forms.MouseEventHandler(this.PreViewBMP_MouseMove);
            this.PreViewBMP.MouseUp += new System.Windows.Forms.MouseEventHandler(this.PreViewBMP_MouseUp);
            // 
            // cancelbutton
            // 
            this.cancelbutton.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.cancelbutton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.cancelbutton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cancelbutton.Location = new System.Drawing.Point(2, 41);
            this.cancelbutton.Name = "cancelbutton";
            this.cancelbutton.Size = new System.Drawing.Size(95, 24);
            this.cancelbutton.TabIndex = 4;
            this.cancelbutton.Text = "Cancel";
            this.cancelbutton.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            this.cancelbutton.UseVisualStyleBackColor = true;
            // 
            // instructions
            // 
            this.instructions.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.instructions.BackColor = System.Drawing.Color.WhiteSmoke;
            this.instructions.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.instructions.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.instructions.Controls.Add(this.label18);
            this.instructions.Controls.Add(this.label7);
            this.instructions.Controls.Add(this.label6);
            this.instructions.Controls.Add(this.label16);
            this.instructions.Controls.Add(this.label2);
            this.instructions.Controls.Add(this.label13);
            this.instructions.Controls.Add(this.label12);
            this.instructions.Controls.Add(this.label5);
            this.instructions.Controls.Add(this.label4);
            this.instructions.Location = new System.Drawing.Point(6, 439);
            this.instructions.Name = "instructions";
            this.instructions.Size = new System.Drawing.Size(182, 76);
            this.instructions.TabIndex = 19;
            // 
            // label18
            // 
            this.label18.AutoSize = true;
            this.label18.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label18.Location = new System.Drawing.Point(3, 57);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(110, 12);
            this.label18.TabIndex = 22;
            this.label18.Text = "Delete Node  - Delete Key";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label7.Location = new System.Drawing.Point(3, 59);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(110, 12);
            this.label7.TabIndex = 22;
            this.label7.Text = "Delete Node  - Delete Key";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label6.Location = new System.Drawing.Point(3, 15);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(109, 12);
            this.label6.TabIndex = 21;
            this.label6.Text = "Move / Select - Left Click";
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label16.Location = new System.Drawing.Point(3, 43);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(134, 12);
            this.label16.TabIndex = 20;
            this.label16.Text = "Insert Node  - CTRL + Left Click";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label2.Location = new System.Drawing.Point(3, 40);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(134, 12);
            this.label2.TabIndex = 20;
            this.label2.Text = "Insert Node  - CTRL + Left Click";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label13.Location = new System.Drawing.Point(3, 29);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(94, 12);
            this.label13.TabIndex = 20;
            this.label13.Text = "Add Node  - Left Click";
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label12.Location = new System.Drawing.Point(3, 1);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(115, 12);
            this.label12.TabIndex = 19;
            this.label12.Text = "Pan and Scan  - Right Click";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label5.Location = new System.Drawing.Point(3, 27);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(94, 12);
            this.label5.TabIndex = 20;
            this.label5.Text = "Add Node  - Left Click";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label4.Location = new System.Drawing.Point(3, 1);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(115, 12);
            this.label4.TabIndex = 19;
            this.label4.Text = "Pan and Scan  - Right Click";
            // 
            // ViewAll
            // 
            this.ViewAll.AutoSize = true;
            this.ViewAll.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.75F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ViewAll.Location = new System.Drawing.Point(7, 117);
            this.ViewAll.Name = "ViewAll";
            this.ViewAll.Size = new System.Drawing.Size(85, 16);
            this.ViewAll.TabIndex = 23;
            this.ViewAll.Text = "Edit All Splines";
            this.ViewAll.UseVisualStyleBackColor = true;
            this.ViewAll.CheckedChanged += new System.EventHandler(this.ViewAll_CheckedChanged);
            // 
            // PropertyPanel
            // 
            this.PropertyPanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.PropertyPanel.BackColor = System.Drawing.SystemColors.ControlLight;
            this.PropertyPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.PropertyPanel.Controls.Add(this.label11);
            this.PropertyPanel.Controls.Add(this.label10);
            this.PropertyPanel.Controls.Add(this.SelectPanel);
            this.PropertyPanel.Controls.Add(this.NodePanel);
            this.PropertyPanel.Controls.Add(this.label9);
            this.PropertyPanel.Controls.Add(this.fillPanel);
            this.PropertyPanel.Controls.Add(this.label8);
            this.PropertyPanel.Controls.Add(this.ColorPanel);
            this.PropertyPanel.Controls.Add(this.label3);
            this.PropertyPanel.Controls.Add(this.label17);
            this.PropertyPanel.Controls.Add(this.label1);
            this.PropertyPanel.Controls.Add(this.TenNum);
            this.PropertyPanel.Controls.Add(this.OPNum);
            this.PropertyPanel.Controls.Add(this.mwsNum);
            this.PropertyPanel.Controls.Add(this.AntiAliasBox);
            this.PropertyPanel.Controls.Add(this.Xparent);
            this.PropertyPanel.Controls.Add(this.FilledBox);
            this.PropertyPanel.Controls.Add(this.Tension);
            this.PropertyPanel.Controls.Add(this.Opaque);
            this.PropertyPanel.Controls.Add(this.ClosedBox);
            this.PropertyPanel.Controls.Add(this.lineWidth);
            this.PropertyPanel.Location = new System.Drawing.Point(427, 438);
            this.PropertyPanel.Name = "PropertyPanel";
            this.PropertyPanel.Size = new System.Drawing.Size(253, 110);
            this.PropertyPanel.TabIndex = 20;
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(181, 7);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(36, 13);
            this.label11.TabIndex = 26;
            this.label11.Text = "Select";
            this.label11.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(114, 7);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(32, 13);
            this.label10.TabIndex = 26;
            this.label10.Text = "Node";
            this.label10.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // SelectPanel
            // 
            this.SelectPanel.BackColor = System.Drawing.Color.Blue;
            this.SelectPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.SelectPanel.Location = new System.Drawing.Point(224, 4);
            this.SelectPanel.Name = "SelectPanel";
            this.SelectPanel.Size = new System.Drawing.Size(24, 18);
            this.SelectPanel.TabIndex = 25;
            this.SelectPanel.Click += new System.EventHandler(this.MultiPanel_Click);
            this.SelectPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.ColorPanel_Paint);
            // 
            // NodePanel
            // 
            this.NodePanel.BackColor = System.Drawing.Color.Red;
            this.NodePanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.NodePanel.Location = new System.Drawing.Point(148, 4);
            this.NodePanel.Name = "NodePanel";
            this.NodePanel.Size = new System.Drawing.Size(24, 18);
            this.NodePanel.TabIndex = 25;
            this.NodePanel.Click += new System.EventHandler(this.MultiPanel_Click);
            this.NodePanel.Paint += new System.Windows.Forms.PaintEventHandler(this.ColorPanel_Paint);
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(63, 7);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(19, 13);
            this.label9.TabIndex = 24;
            this.label9.Text = "Fill";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // fillPanel
            // 
            this.fillPanel.BackColor = System.Drawing.Color.Cornsilk;
            this.fillPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.fillPanel.Location = new System.Drawing.Point(84, 4);
            this.fillPanel.Name = "fillPanel";
            this.fillPanel.Size = new System.Drawing.Size(24, 18);
            this.fillPanel.TabIndex = 23;
            this.fillPanel.Click += new System.EventHandler(this.MultiPanel_Click);
            this.fillPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.ColorPanel_Paint);
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(3, 7);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(26, 13);
            this.label8.TabIndex = 22;
            this.label8.Text = "Pen";
            this.label8.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // ColorPanel
            // 
            this.ColorPanel.BackColor = System.Drawing.Color.Black;
            this.ColorPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ColorPanel.Location = new System.Drawing.Point(33, 3);
            this.ColorPanel.Name = "ColorPanel";
            this.ColorPanel.Size = new System.Drawing.Size(24, 18);
            this.ColorPanel.TabIndex = 19;
            this.ColorPanel.Click += new System.EventHandler(this.MultiPanel_Click);
            this.ColorPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.ColorPanel_Paint);
            // 
            // label3
            // 
            this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(1, 90);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(43, 13);
            this.label3.TabIndex = 17;
            this.label3.Text = "Tension";
            // 
            // label17
            // 
            this.label17.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(2, 44);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(42, 13);
            this.label17.TabIndex = 17;
            this.label17.Text = "Opacity";
            // 
            // label1
            // 
            this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(2, 66);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(33, 13);
            this.label1.TabIndex = 17;
            this.label1.Text = "Width";
            // 
            // TenNum
            // 
            this.TenNum.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.TenNum.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
            this.TenNum.ForeColor = System.Drawing.Color.Red;
            this.TenNum.Location = new System.Drawing.Point(120, 88);
            this.TenNum.Name = "TenNum";
            this.TenNum.Size = new System.Drawing.Size(32, 18);
            this.TenNum.TabIndex = 16;
            this.TenNum.Text = "50";
            this.TenNum.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // OPNum
            // 
            this.OPNum.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.OPNum.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
            this.OPNum.ForeColor = System.Drawing.Color.Red;
            this.OPNum.Location = new System.Drawing.Point(120, 41);
            this.OPNum.Name = "OPNum";
            this.OPNum.Size = new System.Drawing.Size(32, 18);
            this.OPNum.TabIndex = 16;
            this.OPNum.Text = "255";
            this.OPNum.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // mwsNum
            // 
            this.mwsNum.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.mwsNum.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
            this.mwsNum.ForeColor = System.Drawing.Color.Red;
            this.mwsNum.Location = new System.Drawing.Point(120, 63);
            this.mwsNum.Name = "mwsNum";
            this.mwsNum.Size = new System.Drawing.Size(32, 18);
            this.mwsNum.TabIndex = 16;
            this.mwsNum.Text = "1";
            this.mwsNum.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // AntiAliasBox
            // 
            this.AntiAliasBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.AntiAliasBox.AutoSize = true;
            this.AntiAliasBox.Checked = true;
            this.AntiAliasBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.AntiAliasBox.Location = new System.Drawing.Point(158, 89);
            this.AntiAliasBox.Name = "AntiAliasBox";
            this.AntiAliasBox.Size = new System.Drawing.Size(66, 17);
            this.AntiAliasBox.TabIndex = 15;
            this.AntiAliasBox.Text = "AntiAlias";
            this.AntiAliasBox.UseVisualStyleBackColor = true;
            this.AntiAliasBox.CheckedChanged += new System.EventHandler(this.AntiAliasBox_CheckedChanged);
            // 
            // Xparent
            // 
            this.Xparent.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.Xparent.AutoSize = true;
            this.Xparent.Location = new System.Drawing.Point(66, 24);
            this.Xparent.Name = "Xparent";
            this.Xparent.Size = new System.Drawing.Size(109, 17);
            this.Xparent.TabIndex = 15;
            this.Xparent.Text = "Mask Transparent";
            this.Xparent.UseVisualStyleBackColor = true;
            this.Xparent.CheckedChanged += new System.EventHandler(this.Xparent_CheckedChanged);
            // 
            // FilledBox
            // 
            this.FilledBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.FilledBox.AutoSize = true;
            this.FilledBox.Enabled = false;
            this.FilledBox.Location = new System.Drawing.Point(158, 66);
            this.FilledBox.Name = "FilledBox";
            this.FilledBox.Size = new System.Drawing.Size(84, 17);
            this.FilledBox.TabIndex = 15;
            this.FilledBox.Text = "Filled Shape";
            this.FilledBox.UseVisualStyleBackColor = true;
            this.FilledBox.CheckedChanged += new System.EventHandler(this.FilledBox_CheckedChanged);
            // 
            // Tension
            // 
            this.Tension.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.Tension.LargeChange = 1;
            this.Tension.Location = new System.Drawing.Point(49, 89);
            this.Tension.Maximum = 200;
            this.Tension.Name = "Tension";
            this.Tension.Size = new System.Drawing.Size(68, 14);
            this.Tension.TabIndex = 13;
            this.Tension.Value = 50;
            this.Tension.ValueChanged += new System.EventHandler(this.Tension_ValueChanged);
            // 
            // Opaque
            // 
            this.Opaque.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.Opaque.LargeChange = 1;
            this.Opaque.Location = new System.Drawing.Point(49, 43);
            this.Opaque.Maximum = 255;
            this.Opaque.Name = "Opaque";
            this.Opaque.Size = new System.Drawing.Size(68, 14);
            this.Opaque.TabIndex = 13;
            this.Opaque.Value = 255;
            this.Opaque.ValueChanged += new System.EventHandler(this.Opacity_ValueChanged);
            // 
            // ClosedBox
            // 
            this.ClosedBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.ClosedBox.AutoSize = true;
            this.ClosedBox.Enabled = false;
            this.ClosedBox.Location = new System.Drawing.Point(158, 44);
            this.ClosedBox.Name = "ClosedBox";
            this.ClosedBox.Size = new System.Drawing.Size(92, 17);
            this.ClosedBox.TabIndex = 14;
            this.ClosedBox.Text = "Closed Shape";
            this.ClosedBox.UseVisualStyleBackColor = true;
            this.ClosedBox.CheckedChanged += new System.EventHandler(this.ClosedBox_CheckedChanged);
            // 
            // lineWidth
            // 
            this.lineWidth.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.lineWidth.LargeChange = 1;
            this.lineWidth.Location = new System.Drawing.Point(49, 66);
            this.lineWidth.Minimum = 1;
            this.lineWidth.Name = "lineWidth";
            this.lineWidth.Size = new System.Drawing.Size(68, 14);
            this.lineWidth.TabIndex = 13;
            this.lineWidth.Value = 1;
            this.lineWidth.ValueChanged += new System.EventHandler(this.hScrollBar1_ValueChanged);
            // 
            // BGClear
            // 
            this.BGClear.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.BGClear.AutoSize = true;
            this.BGClear.BackColor = System.Drawing.Color.WhiteSmoke;
            this.BGClear.Font = new System.Drawing.Font("Arial Narrow", 7.5F);
            this.BGClear.Location = new System.Drawing.Point(2, 90);
            this.BGClear.Name = "BGClear";
            this.BGClear.Size = new System.Drawing.Size(99, 18);
            this.BGClear.TabIndex = 21;
            this.BGClear.Text = "Delete Background";
            this.BGClear.UseVisualStyleBackColor = false;
            // 
            // ShowHandles
            // 
            this.ShowHandles.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ShowHandles.AutoSize = true;
            this.ShowHandles.BackColor = System.Drawing.Color.WhiteSmoke;
            this.ShowHandles.Checked = true;
            this.ShowHandles.CheckState = System.Windows.Forms.CheckState.Checked;
            this.ShowHandles.Location = new System.Drawing.Point(2, 0);
            this.ShowHandles.Name = "ShowHandles";
            this.ShowHandles.Size = new System.Drawing.Size(94, 17);
            this.ShowHandles.TabIndex = 14;
            this.ShowHandles.Text = "Show Handles";
            this.ShowHandles.UseVisualStyleBackColor = false;
            this.ShowHandles.CheckedChanged += new System.EventHandler(this.ClosedBox_CheckedChanged);
            // 
            // ApplyLines
            // 
            this.ApplyLines.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ApplyLines.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ApplyLines.Location = new System.Drawing.Point(3, -1);
            this.ApplyLines.Name = "ApplyLines";
            this.ApplyLines.Size = new System.Drawing.Size(95, 24);
            this.ApplyLines.TabIndex = 2;
            this.ApplyLines.Text = "Apply Spline";
            this.ApplyLines.UseVisualStyleBackColor = true;
            this.ApplyLines.Click += new System.EventHandler(this.ApplyLines_Click);
            // 
            // colorDialog1
            // 
            this.colorDialog1.AnyColor = true;
            this.colorDialog1.FullOpen = true;
            // 
            // StylePanel
            // 
            this.StylePanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.StylePanel.BackColor = System.Drawing.SystemColors.ControlDark;
            this.StylePanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.StylePanel.Controls.Add(this.SCap);
            this.StylePanel.Controls.Add(this.LStyle);
            this.StylePanel.Controls.Add(this.ECap);
            this.StylePanel.Location = new System.Drawing.Point(427, 548);
            this.StylePanel.Name = "StylePanel";
            this.StylePanel.Size = new System.Drawing.Size(355, 29);
            this.StylePanel.TabIndex = 23;
            // 
            // SCap
            // 
            this.SCap.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.SCap.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.SCap.FormattingEnabled = true;
            this.SCap.Items.AddRange(new object[] {
            "No Start Cap",
            "Start Arrow",
            "Start Diamond",
            "Start Flat",
            "Start Round",
            "Start Ball",
            "Start Square",
            "Start BigSquare",
            "Start Triangle"});
            this.SCap.Location = new System.Drawing.Point(9, 3);
            this.SCap.Name = "SCap";
            this.SCap.Size = new System.Drawing.Size(106, 20);
            this.SCap.TabIndex = 1;
            this.SCap.SelectedIndexChanged += new System.EventHandler(this.ALL_SelectedIndexChanged);
            // 
            // LStyle
            // 
            this.LStyle.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.LStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LStyle.FormattingEnabled = true;
            this.LStyle.Items.AddRange(new object[] {
            "Solid Line",
            "Dash Line",
            "DashDot Line",
            "DashDotDot Line",
            "Dot Line"});
            this.LStyle.Location = new System.Drawing.Point(126, 3);
            this.LStyle.Name = "LStyle";
            this.LStyle.Size = new System.Drawing.Size(106, 20);
            this.LStyle.TabIndex = 1;
            this.LStyle.SelectedIndexChanged += new System.EventHandler(this.ALL_SelectedIndexChanged);
            // 
            // ECap
            // 
            this.ECap.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.ECap.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ECap.FormattingEnabled = true;
            this.ECap.Items.AddRange(new object[] {
            "No End Cap",
            "End Arrow",
            "End Diamond",
            "End Flat",
            "End Round",
            "End Ball",
            "End Square",
            "End BigSquare",
            "End Triangle"});
            this.ECap.Location = new System.Drawing.Point(243, 3);
            this.ECap.Name = "ECap";
            this.ECap.Size = new System.Drawing.Size(106, 20);
            this.ECap.TabIndex = 1;
            this.ECap.SelectedIndexChanged += new System.EventHandler(this.ALL_SelectedIndexChanged);
            // 
            // SplineList
            // 
            this.SplineList.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.SplineList.FormattingEnabled = true;
            this.SplineList.ItemHeight = 12;
            this.SplineList.Location = new System.Drawing.Point(4, 24);
            this.SplineList.Name = "SplineList";
            this.SplineList.Size = new System.Drawing.Size(124, 76);
            this.SplineList.TabIndex = 24;
            this.SplineList.SelectedIndexChanged += new System.EventHandler(this.SplineList_SelectedIndexChanged);
            // 
            // Reset
            // 
            this.Reset.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.Reset.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Reset.Location = new System.Drawing.Point(3, 20);
            this.Reset.Name = "Reset";
            this.Reset.Size = new System.Drawing.Size(95, 24);
            this.Reset.TabIndex = 25;
            this.Reset.Text = "Clear Spline";
            this.Reset.UseVisualStyleBackColor = true;
            this.Reset.Click += new System.EventHandler(this.Reset_Click);
            // 
            // Export
            // 
            this.Export.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.Export.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Export.Location = new System.Drawing.Point(3, 63);
            this.Export.Name = "Export";
            this.Export.Size = new System.Drawing.Size(95, 24);
            this.Export.TabIndex = 25;
            this.Export.Text = "Export Splines";
            this.Export.UseVisualStyleBackColor = true;
            this.Export.Click += new System.EventHandler(this.Export_Click);
            // 
            // Import
            // 
            this.Import.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.Import.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Import.Location = new System.Drawing.Point(3, 84);
            this.Import.Name = "Import";
            this.Import.Size = new System.Drawing.Size(95, 24);
            this.Import.TabIndex = 25;
            this.Import.Text = "Import Splines";
            this.Import.UseVisualStyleBackColor = true;
            this.Import.Click += new System.EventHandler(this.Import_Click);
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.FileName = "openFileDialog1";
            // 
            // ApplyAll
            // 
            this.ApplyAll.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ApplyAll.AutoSize = true;
            this.ApplyAll.Font = new System.Drawing.Font("Arial", 7F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Italic | System.Drawing.FontStyle.Underline))));
            this.ApplyAll.ForeColor = System.Drawing.Color.Blue;
            this.ApplyAll.Location = new System.Drawing.Point(0, 104);
            this.ApplyAll.Name = "ApplyAll";
            this.ApplyAll.Size = new System.Drawing.Size(50, 13);
            this.ApplyAll.TabIndex = 26;
            this.ApplyAll.Text = "Apply All";
            this.ApplyAll.Click += new System.EventHandler(this.ApplyAll_Click);
            // 
            // Remove
            // 
            this.Remove.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.Remove.AutoSize = true;
            this.Remove.Font = new System.Drawing.Font("Arial", 7F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Italic | System.Drawing.FontStyle.Underline))));
            this.Remove.ForeColor = System.Drawing.Color.Blue;
            this.Remove.Location = new System.Drawing.Point(20, 120);
            this.Remove.Name = "Remove";
            this.Remove.Size = new System.Drawing.Size(83, 13);
            this.Remove.TabIndex = 26;
            this.Remove.Text = "Delete Selected";
            this.Remove.Click += new System.EventHandler(this.Remove_Click);
            // 
            // SplineName
            // 
            this.SplineName.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.SplineName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.SplineName.Location = new System.Drawing.Point(4, 2);
            this.SplineName.Name = "SplineName";
            this.SplineName.Size = new System.Drawing.Size(123, 18);
            this.SplineName.TabIndex = 27;
            this.SplineName.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox1_KeyPress);
            // 
            // ListPanel
            // 
            this.ListPanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ListPanel.BackColor = System.Drawing.Color.WhiteSmoke;
            this.ListPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ListPanel.Controls.Add(this.SplineList);
            this.ListPanel.Controls.Add(this.SaveXform);
            this.ListPanel.Controls.Add(this.ApplyAll);
            this.ListPanel.Controls.Add(this.SplineName);
            this.ListPanel.Controls.Add(this.Remove);
            this.ListPanel.Location = new System.Drawing.Point(189, 438);
            this.ListPanel.Name = "ListPanel";
            this.ListPanel.Size = new System.Drawing.Size(135, 139);
            this.ListPanel.TabIndex = 28;
            // 
            // SaveXform
            // 
            this.SaveXform.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.SaveXform.AutoSize = true;
            this.SaveXform.Font = new System.Drawing.Font("Arial", 7F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Italic | System.Drawing.FontStyle.Underline))));
            this.SaveXform.ForeColor = System.Drawing.Color.Blue;
            this.SaveXform.Location = new System.Drawing.Point(54, 104);
            this.SaveXform.Name = "SaveXform";
            this.SaveXform.Size = new System.Drawing.Size(78, 13);
            this.SaveXform.TabIndex = 26;
            this.SaveXform.Text = "Save Transform";
            this.SaveXform.Click += new System.EventHandler(this.SaveXform_Click);
            // 
            // SpinePanel
            // 
            this.SpinePanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.SpinePanel.BackColor = System.Drawing.Color.LightGray;
            this.SpinePanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.SpinePanel.Controls.Add(this.ViewAll);
            this.SpinePanel.Controls.Add(this.Clone);
            this.SpinePanel.Controls.Add(this.Export);
            this.SpinePanel.Controls.Add(this.ApplyLines);
            this.SpinePanel.Controls.Add(this.Reset);
            this.SpinePanel.Controls.Add(this.Import);
            this.SpinePanel.Location = new System.Drawing.Point(324, 438);
            this.SpinePanel.Name = "SpinePanel";
            this.SpinePanel.Size = new System.Drawing.Size(103, 139);
            this.SpinePanel.TabIndex = 29;
            // 
            // Clone
            // 
            this.Clone.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.Clone.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Clone.Location = new System.Drawing.Point(3, 42);
            this.Clone.Name = "Clone";
            this.Clone.Size = new System.Drawing.Size(95, 24);
            this.Clone.TabIndex = 26;
            this.Clone.Text = "Clone Spline";
            this.Clone.UseVisualStyleBackColor = true;
            this.Clone.Click += new System.EventHandler(this.Clone_Click);
            // 
            // ActionPanel
            // 
            this.ActionPanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.ActionPanel.BackColor = System.Drawing.Color.WhiteSmoke;
            this.ActionPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.ActionPanel.Controls.Add(this.ReDoButton);
            this.ActionPanel.Controls.Add(this.cancelbutton);
            this.ActionPanel.Controls.Add(this.BGClear);
            this.ActionPanel.Controls.Add(this.buttonOK);
            this.ActionPanel.Controls.Add(this.ShowHandles);
            this.ActionPanel.Location = new System.Drawing.Point(681, 437);
            this.ActionPanel.Name = "ActionPanel";
            this.ActionPanel.Size = new System.Drawing.Size(100, 110);
            this.ActionPanel.TabIndex = 30;
            // 
            // ReDoButton
            // 
            this.ReDoButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.ReDoButton.Location = new System.Drawing.Point(2, 17);
            this.ReDoButton.Name = "ReDoButton";
            this.ReDoButton.Size = new System.Drawing.Size(95, 24);
            this.ReDoButton.TabIndex = 22;
            this.ReDoButton.Text = "Erase Lines";
            this.ReDoButton.TextAlign = System.Drawing.ContentAlignment.TopCenter;
            this.ReDoButton.UseVisualStyleBackColor = true;
            this.ReDoButton.Click += new System.EventHandler(this.RedoLines_Click);
            // 
            // XFormPanel
            // 
            this.XFormPanel.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
            this.XFormPanel.BackColor = System.Drawing.Color.WhiteSmoke;
            this.XFormPanel.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.XFormPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.XFormPanel.Controls.Add(this.label14);
            this.XFormPanel.Controls.Add(this.label15);
            this.XFormPanel.Controls.Add(this.label21);
            this.XFormPanel.Controls.Add(this.label19);
            this.XFormPanel.Controls.Add(this.label20);
            this.XFormPanel.Controls.Add(this.label22);
            this.XFormPanel.Controls.Add(this.label25);
            this.XFormPanel.Location = new System.Drawing.Point(6, 514);
            this.XFormPanel.Name = "XFormPanel";
            this.XFormPanel.Size = new System.Drawing.Size(182, 64);
            this.XFormPanel.TabIndex = 19;
            // 
            // label14
            // 
            this.label14.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label14.AutoSize = true;
            this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label14.Location = new System.Drawing.Point(3, 29);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(160, 12);
            this.label14.TabIndex = 22;
            this.label14.Text = "Size Evenly-SHFT+CTRL+Right Click";
            // 
            // label15
            // 
            this.label15.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label15.AutoSize = true;
            this.label15.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label15.Location = new System.Drawing.Point(3, 15);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(152, 12);
            this.label15.TabIndex = 22;
            this.label15.Text = "Resize Shape  - SHIFT + Right Click";
            // 
            // label19
            // 
            this.label19.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label19.AutoSize = true;
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label19.Location = new System.Drawing.Point(3, 3);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(145, 12);
            this.label19.TabIndex = 22;
            this.label19.Text = "Move Shape  - CTRL + Right Click";
            // 
            // label20
            // 
            this.label20.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label20.AutoSize = true;
            this.label20.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label20.Location = new System.Drawing.Point(3, -11);
            this.label20.Name = "label20";
            this.label20.Size = new System.Drawing.Size(139, 12);
            this.label20.TabIndex = 22;
            this.label20.Text = "Rotate Shape - ALT + Right Click";
            // 
            // label22
            // 
            this.label22.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label22.AutoSize = true;
            this.label22.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label22.Location = new System.Drawing.Point(3, -63);
            this.label22.Name = "label22";
            this.label22.Size = new System.Drawing.Size(109, 12);
            this.label22.TabIndex = 21;
            this.label22.Text = "Move / Select - Left Click";
            // 
            // label25
            // 
            this.label25.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label25.AutoSize = true;
            this.label25.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label25.Location = new System.Drawing.Point(3, -76);
            this.label25.Name = "label25";
            this.label25.Size = new System.Drawing.Size(115, 12);
            this.label25.TabIndex = 19;
            this.label25.Text = "Pan and Scan  - Right Click";
            // 
            // pictureBox1
            // 
            this.pictureBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.pictureBox1.BackgroundImage = global::TRsSplineMaster.Properties.Resources.avatarBG1;
            this.pictureBox1.Location = new System.Drawing.Point(0, 437);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(797, 139);
            this.pictureBox1.TabIndex = 31;
            this.pictureBox1.TabStop = false;
            // 
            // label21
            // 
            this.label21.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label21.AutoSize = true;
            this.label21.Font = new System.Drawing.Font("Microsoft Sans Serif", 6.5F);
            this.label21.Location = new System.Drawing.Point(3, 44);
            this.label21.Name = "label21";
            this.label21.Size = new System.Drawing.Size(141, 12);
            this.label21.TabIndex = 22;
            this.label21.Text = "Rotate Shape  - ALT + Right Click";
            // 
            // EffectPluginConfigDialog
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.AutoValidate = System.Windows.Forms.AutoValidate.EnablePreventFocusChange;
            this.BackColor = System.Drawing.SystemColors.Control;
            this.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.CancelButton = this.cancelbutton;
            this.ClientSize = new System.Drawing.Size(794, 579);
            this.Controls.Add(this.PreViewBMP);
            this.Controls.Add(this.ActionPanel);
            this.Controls.Add(this.SpinePanel);
            this.Controls.Add(this.XFormPanel);
            this.Controls.Add(this.ListPanel);
            this.Controls.Add(this.StylePanel);
            this.Controls.Add(this.PropertyPanel);
            this.Controls.Add(this.instructions);
            this.Controls.Add(this.pictureBox1);
            this.DoubleBuffered = true;
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 7F);
            this.KeyPreview = true;
            this.Location = new System.Drawing.Point(0, 0);
            this.Name = "EffectPluginConfigDialog";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Tag = "false";
            this.Text = "v";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.EffectPluginConfigDialog_Load);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.EffectPluginConfigDialog_Paint);
            this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.EffectPluginConfigDialog_KeyDown);
            this.Resize += new System.EventHandler(this.EffectPluginConfigDialog_Resize);
            this.Controls.SetChildIndex(this.pictureBox1, 0);
            this.Controls.SetChildIndex(this.instructions, 0);
            this.Controls.SetChildIndex(this.PropertyPanel, 0);
            this.Controls.SetChildIndex(this.StylePanel, 0);
            this.Controls.SetChildIndex(this.ListPanel, 0);
            this.Controls.SetChildIndex(this.XFormPanel, 0);
            this.Controls.SetChildIndex(this.SpinePanel, 0);
            this.Controls.SetChildIndex(this.ActionPanel, 0);
            this.Controls.SetChildIndex(this.PreViewBMP, 0);
            this.instructions.ResumeLayout(false);
            this.instructions.PerformLayout();
            this.PropertyPanel.ResumeLayout(false);
            this.PropertyPanel.PerformLayout();
            this.StylePanel.ResumeLayout(false);
            this.ListPanel.ResumeLayout(false);
            this.ListPanel.PerformLayout();
            this.SpinePanel.ResumeLayout(false);
            this.SpinePanel.PerformLayout();
            this.ActionPanel.ResumeLayout(false);
            this.ActionPanel.PerformLayout();
            this.XFormPanel.ResumeLayout(false);
            this.XFormPanel.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }


        private void EffectPluginConfigDialog_Load(object sender, EventArgs e)
        {
             MyBounds = EffectSourceSurface.Bounds;

            //=====make checkerboard
            CheckerBG = new Bitmap(MyBounds.Width, MyBounds.Height);
            Surface tmp = new Surface(EffectSourceSurface.Size);
            tmp.ClearWithCheckerboardPattern();
            Bitmap b = new RenderArgs(tmp).Bitmap;
            Graphics g = Graphics.FromImage(CheckerBG);
            g.DrawImage(b, 0, 0);
            g.Dispose();
            tmp.Dispose();
            GC.Collect();

            //overlay
            OverlayBMP = new Bitmap(MyBounds.Width, MyBounds.Height);

            //get bounds
            if (PreViewBMP.Width >= MyBounds.Width)
            {
                PreViewBMP.Width = MyBounds.Width;
                PreViewBMP.Left = (this.ClientRectangle.Width - PreViewBMP.Width) / 2;
                
            }

            if (PreViewBMP.Height >= MyBounds.Height)PreViewBMP.Height = MyBounds.Height;

            Version version =  Assembly.GetExecutingAssembly().GetName().Version;
            this.Text = EffectPlugin.StaticName + " ver. " + version.Major + "." + version.Minor + "." + version.Build;
            SCap.SelectedIndex = 0;
            ECap.SelectedIndex = 0;
            LStyle.SelectedIndex = 0;
            this.WindowState = FormWindowState.Maximized;

        }


        private unsafe void savebutton_Click(object sender, EventArgs e)
        {
            ApplyChanges();
            Bitmap basebmp = new Bitmap(MyBounds.Width, MyBounds.Height);
            Bitmap bMap = new RenderArgs(EffectSourceSurface).Bitmap;
            Graphics b = Graphics.FromImage(basebmp);
            b.CompositingMode = CompositingMode.SourceOver;
            if (Xparent.Checked)
            {
                b.DrawImage(bMap, 0, 0);
                BitmapData bmdTo = basebmp.LockBits(new Rectangle(0, 0, MyBounds.Width, MyBounds.Height), System.Drawing.Imaging.ImageLockMode.ReadWrite, basebmp.PixelFormat);
                BitmapData bmdFrom= OverlayBMP.LockBits(new Rectangle(0, 0, MyBounds.Width, MyBounds.Height), System.Drawing.Imaging.ImageLockMode.ReadWrite, OverlayBMP.PixelFormat);
                
                byte* rowsfrom = (byte*)bmdFrom.Scan0;
                byte* rowsto = (byte*)bmdTo.Scan0;
                for (int y = 0; y < MyBounds.Height; y++)
                {
                    for (int x = 0; x < MyBounds.Width; x++)
                    {
                        rowsto[y * bmdTo.Stride + 4 * x + 3] = rowsfrom[y * bmdFrom.Stride + 4 * x + 3];
                    }
                }
                basebmp.UnlockBits(bmdTo);
                OverlayBMP.UnlockBits(bmdFrom);
            }
            else
            {
                if (!BGClear.Checked) b.DrawImage(bMap, 0, 0);
                b.DrawImage(OverlayBMP, 0, 0);
            }

            //save
            basebmp.Save(System.IO.Path.GetTempPath() + @"TRSM.bmp");
            
            b.Dispose();
            bMap.Dispose();
            basebmp.Dispose();
            saver = true;

            //=======================================
            base.FinishTokenUpdate();
            this.DialogResult = DialogResult.OK;
            this.Close();

        }

        private void ApplyChanges()
        {
            try
            {
                Graphics b = Graphics.FromImage(OverlayBMP);
                b.CompositingMode = CompositingMode.SourceOver;

                if (AntiAliasBox.Checked)
                {
                    b.SmoothingMode = SmoothingMode.AntiAlias;
                }
                else
                {
                    b.SmoothingMode = SmoothingMode.None;
                }

                float tense = (float)Tension.Value / 100;
                Color cx = ColorPanel.BackColor;
                Pen pen = new Pen(cx);
                pen.Color = Color.FromArgb(Opaque.Value, cx.R, cx.G, cx.B);
                pen.Width = lineWidth.Value;
                pen.DashStyle = (DashStyle)DStyle[LStyle.SelectedIndex];
                pen.StartCap = (LineCap)SECap[SCap.SelectedIndex];
                pen.EndCap = (LineCap)SECap[ECap.SelectedIndex];
                cx = fillPanel.BackColor;
                SolidBrush brush = new SolidBrush(cx);
                brush.Color = Color.FromArgb(Opaque.Value, cx.R, cx.G, cx.B);
                if (Nodes.Length > 1)
                {
                    if (ClosedBox.Checked & !FilledBox.Checked)
                    {
                        b.DrawClosedCurve(pen, Nodes, tense, FillMode.Alternate);
                    }
                    else if (ClosedBox.Checked & FilledBox.Checked)
                    {
                        b.FillClosedCurve(brush, Nodes, FillMode.Alternate, tense);
                    }
                    else
                    {
                        b.DrawCurve(pen, Nodes, tense);
                    }
                }
                pen.Dispose();
                brush.Dispose();
                b.Dispose();
            }
            catch (Exception e) { }
        }

        private void PreViewBMP_MouseMove(object sender, MouseEventArgs e)
        {
            if (MoveFlag)
            {
                Nodes[NodeSelect].X = e.X + PanBase.X;
                Nodes[NodeSelect].Y = e.Y + PanBase.Y;
                DrawGraphics();
            }

            if (PanFlag)
            {

                motion = new Point(e.X, e.Y);
                if (Control.ModifierKeys != 0)
                {
                    if ((Control.ModifierKeys == Keys.Shift) | (Control.ModifierKeys == (Keys.Shift | Keys.Control)))
                    {//resize
                        if (Nodes.Length > 0) anchor = true;
                        double xscale = (motion.X - Center.X) / (premotion.X - Center.X + .1);
                        double yscale = xscale;
                        if (Control.ModifierKeys == Keys.Shift) yscale = (motion.Y - Center.Y) / (premotion.Y - Center.Y + .1);
                        
                        Nodes = MyUtils.ScaleArray(cloneNodes, Center, xscale, yscale);

                        if (ViewAll.Checked)
                        {
                            xscale = (motion.X - FullCenter.X) / (premotion.X - FullCenter.X + .1);
                            yscale = xscale;
                            if (Control.ModifierKeys == Keys.Shift) yscale = (motion.Y - FullCenter.Y) / (premotion.Y - FullCenter.Y + .1);

                            for (int i = 0; i < Splines.Count; i++)
                            {
                                Point[] xform = (Point[])Splines[i];
                                cloneSplines[i] = MyUtils.ScaleArray(xform, FullCenter, xscale, yscale);
                            }
                        }

                    }
                    else if (Control.ModifierKeys == Keys.Alt)
                    {//Rotate
                        if (Nodes.Length > 0) anchor = true;
                        double rads = Math.Atan2(motion.Y - Center.Y, Center.X - motion.X);
                        double PreRads = Math.Atan2(premotion.Y - Center.Y, Center.X - premotion.X);

                        Nodes = MyUtils.RotateArray(cloneNodes, Center, PreRads, rads);

                        if (ViewAll.Checked)
                        {
                            rads = Math.Atan2(motion.Y - FullCenter.Y, FullCenter.X - motion.X);
                            PreRads = Math.Atan2(premotion.Y - FullCenter.Y, FullCenter.X - premotion.X);
                            for (int i = 0; i < Splines.Count; i++)
                            {
                                Point[] xform = (Point[])Splines[i];
                                cloneSplines[i] = MyUtils.RotateArray(xform, FullCenter, PreRads, rads);
                            }
                        }

                    }
                    else if (Control.ModifierKeys == Keys.Control)
                    {//Move
                        anchor = false;
                        int movex = motion.X - premotion.X;
                        premotion.X = motion.X;
                        int movey = motion.Y - premotion.Y;
                        premotion.Y = motion.Y;


                        Nodes = MyUtils.ShiftArray(Nodes, movex, movey);

                        if (ViewAll.Checked)
                        {
                            for (int i = 0; i < Splines.Count; i++)
                            {
                                Point[] xform = (Point[])cloneSplines[i];
                                cloneSplines[i] = MyUtils.ShiftArray(xform, movex, movey);
                            }
                        }

                    }
                }
                else
                {//  pan
                    int movex = premotion.X - motion.X + PanBase.X;
                    premotion.X = motion.X;
                    int movey = premotion.Y - motion.Y + PanBase.Y;
                    premotion.Y = motion.Y;
                    if (PreViewBMP.Width < MyBounds.Width) PanBase.X = MyUtils.clamp(movex, 0, MyBounds.Width - PreViewBMP.Width);
                    if (PreViewBMP.Height < MyBounds.Height) PanBase.Y = MyUtils.clamp(movey, 0, MyBounds.Height - PreViewBMP.Height);
                }
                DrawGraphics();
            }
        }

        private void DrawGraphics()
        {
            ClosedBox.Enabled = (Nodes.Length > 2);
            FilledBox.Enabled = ClosedBox.Enabled;
            if (!ClosedBox.Enabled) ClosedBox.Checked = false;
            if (!FilledBox.Enabled) FilledBox.Checked = false;
            try
            {
                Bitmap basebmp = new Bitmap(MyBounds.Width, MyBounds.Height);
                Bitmap bMap = new RenderArgs(EffectSourceSurface).Bitmap;
                Graphics b = Graphics.FromImage(basebmp);
                b.CompositingMode = CompositingMode.SourceOver;

                if (AntiAliasBox.Checked)
                {
                    b.SmoothingMode = SmoothingMode.AntiAlias;
                }
                else
                {
                    b.SmoothingMode = SmoothingMode.None;
                }


                //add Checker layer
                b.DrawImage(CheckerBG, 0, 0);

                //add image layer
                b.DrawImage(bMap, 0, 0);

                //add overlay
                b.DrawImage(OverlayBMP, 0, 0);

                float tense = (float)Tension.Value / 100;
                Color cx = ColorPanel.BackColor;
                Pen pen = new Pen(cx);
                pen.Color = Color.FromArgb(Opaque.Value, cx.R, cx.G, cx.B);
                pen.Width = lineWidth.Value;
                pen.DashStyle = (DashStyle)DStyle[LStyle.SelectedIndex];
                pen.StartCap = (LineCap)SECap[SCap.SelectedIndex];
                pen.EndCap = (LineCap)SECap[ECap.SelectedIndex];

                cx = fillPanel.BackColor;
                SolidBrush brush = new SolidBrush(cx);
                brush.Color = Color.FromArgb(Opaque.Value, cx.R, cx.G, cx.B);

                if (Nodes.Length > 1)
                {
                    if (ClosedBox.Checked & !FilledBox.Checked)
                    {
                        b.DrawClosedCurve(pen, Nodes, tense, FillMode.Alternate);
                    }
                    else if (ClosedBox.Checked & FilledBox.Checked)
                    {
                        b.FillClosedCurve(brush, Nodes, FillMode.Alternate, tense);
                    }
                    else
                    {
                        b.DrawCurve(pen, Nodes, tense);
                    }
                }
                
                pen.Dispose();
                brush.Dispose();

                //See All preview================
                if (ViewAll.Checked && (cloneSplines.Count > 0))
                {
                    Point[] xform =new Point[0];
                    Pen p = new Pen(SelectPanel.BackColor);
                    for (int i = 0; i < cloneSplines.Count; i++)
                    {
                        xform = (Point[])cloneSplines[i];
                        if (xform.Length > 1) b.DrawCurve(p, xform, tense);
                    }
                    p.Dispose();
                }
                //=========================
                if ((Nodes.Length > 0) && ShowHandles.Checked)
                {
                    for (int i = 0; i < Nodes.Length; i++)
                    {
                        if (i == NodeSelect)
                        {
                            Pen p = new Pen(SelectPanel.BackColor);
                            b.DrawEllipse(p, Nodes[i].X - 5, Nodes[i].Y - 5, 10, 10);
                            p.Dispose();
                        }
                        else
                        {
                            Pen p = new Pen(NodePanel.BackColor);
                            b.DrawEllipse(p, Nodes[i].X - 5, Nodes[i].Y - 5, 10, 10);
                            p.Dispose();
                        }
                    }
                    if (anchor)
                    {
                        Pen p = new Pen(SelectPanel.BackColor);
                        b.DrawEllipse(p, Center.X - 5, Center.Y - 5, 10, 10);
                        p.Dispose();
                    }
                }

                //draw on screen
                Graphics g = PreViewBMP.CreateGraphics();
                g.CompositingMode = CompositingMode.SourceOver;

                g.DrawImage(basebmp, PreViewBMP.ClientRectangle, PanBase.X, PanBase.Y, PreViewBMP.Bounds.Width,
                    PreViewBMP.Bounds.Height, GraphicsUnit.Pixel);
                g.Dispose();
                b.Dispose();
                bMap.Dispose();
                basebmp.Dispose();
                GC.Collect();
            }
            catch (Exception e) { }

        }


        private void PreViewBMP_MouseDown(object sender, MouseEventArgs e)
        {
            premotion = new Point(e.X, e.Y);
            fixmotion = new Point(e.X + PanBase.X, e.Y + PanBase.Y);
            if (Nodes.Length>0)Center = MyUtils.Centroid(Nodes);

            if (e.Button == MouseButtons.Right)
            {
                PanFlag = true;
                cloneNodes = (Point[])Nodes.Clone();
                if (ViewAll.Checked)
                {
                    cloneSplines = (ArrayList)Splines.Clone();
                    FullCenter=new Point();
                    for (int i = 0; i < cloneSplines.Count;i++ )
                    {
                        Point[] xform =(Point[])cloneSplines[i];
                        Point fc= MyUtils.Centroid(xform);
                        FullCenter.X += fc.X;
                        FullCenter.Y += fc.Y;
                    }
                    if (cloneSplines.Count > 0)
                    {
                        FullCenter.X /= cloneSplines.Count;
                        FullCenter.Y /= cloneSplines.Count;
                    }
                }

            }
            else if (e.Button == MouseButtons.Left)
            {
                if (CheckNode())
                {//move node
                    MoveFlag = true;
                }
                else if (Control.ModifierKeys == Keys.Control)
                {
                    if (NodeSelect >= 0)
                    {
                        Nodes = MyUtils.InsertP(Nodes, NodeSelect,fixmotion);
                        NodeSelect = -1;
                    }
                }
                else
                {//add node
                    Array.Resize(ref Nodes, Nodes.Length + 1);
                    Nodes[Nodes.Length - 1] = fixmotion;
                }
            }

        }

        private void PreViewBMP_MouseUp(object sender, MouseEventArgs e)
        {

            PanFlag = false;
            MoveFlag = false;
            anchor = false;
            DrawGraphics();
            
        }

        private void hScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            mwsNum.Text = lineWidth.Value.ToString();
            DrawGraphics();
        }
        private void Opacity_ValueChanged(object sender, EventArgs e)
        {
            OPNum.Text = Opaque.Value.ToString();
            DrawGraphics();
        }
       

        private void PreViewBMP_Paint(object sender, PaintEventArgs e)
        {
            DrawGraphics();

        }


        private bool CheckNode()
        {
            
            if (Nodes.Length == 0) return false;
            bool results = false;
            for (int i=0; i < Nodes.Length;i++)
            {
                if (MyUtils.PythagP(Nodes[i], fixmotion) <= 5)
                {
                    results = true;
                    NodeSelect = i;
                }
                
            }
            return results;
        }

        private void ClosedBox_CheckedChanged(object sender, EventArgs e)
        {
           if (ClosedBox.Enabled) DrawGraphics();
        }

        private void FilledBox_CheckedChanged(object sender, EventArgs e)
        {
            if (FilledBox.Enabled) DrawGraphics(); 
        }

        private void Tension_ValueChanged(object sender, EventArgs e)
        {
            TenNum.Text = Tension.Value.ToString();
            DrawGraphics();
        }

        private void AntiAliasBox_CheckedChanged(object sender, EventArgs e)
        {
            DrawGraphics();
        }

 
        private void PreViewBMP_LoadCompleted(object sender, AsyncCompletedEventArgs e)
        {
            DrawGraphics();
        }

        private void EffectPluginConfigDialog_Paint(object sender, PaintEventArgs e)
        {
            DrawGraphics();
        }

        private void ApplyLines_Click(object sender, EventArgs e)
        {
            if (Nodes.Length == 0) return;

            ApplyChanges();
            if (SplineList.SelectedIndex > -1)
            {
                Splines[SplineList.SelectedIndex]= Nodes;
            }
            else
            {

                if (Splines.Count < 100)
                {
                    Splines.Add(Nodes);
                    SplineList.Items.Add("Spline" + Convert.ToString(SplineList.Items.Count + 1));
                }
                else
                {
                    MessageBox.Show("Too Many Splines in List (Max 99)", "List Full", MessageBoxButtons.OK);

                }
            }
            
            Array.Resize(ref Nodes, 0);
            NodeSelect = -1;
            SplineList.SelectedIndex = -1;
            DrawGraphics();
        }

        private void MultiPanel_Click(object sender, EventArgs e)
        {
            
            Panel p = (Panel)sender;
            colorDialog1.Color = p.BackColor;
            colorDialog1.ShowDialog();
            p.BackColor = colorDialog1.Color;
            DrawGraphics();
        }


        private void ALL_SelectedIndexChanged(object sender, EventArgs e)
        {
            DrawGraphics();

        }


        private void Reset_Click(object sender, EventArgs e)
        {
            Array.Resize(ref Nodes, 0);
            NodeSelect = -1;
            SplineList.SelectedIndex = -1;
            DrawGraphics();
        }


        private void EffectPluginConfigDialog_KeyDown(object sender, KeyEventArgs e)
        {
            if (NodeSelect < 0) return;

            if (e.KeyCode == Keys.Delete)
            {
                Nodes = MyUtils.RemoveP(Nodes, NodeSelect);
                NodeSelect = -1;
                DrawGraphics();
            }

        }

        private void Remove_Click(object sender, EventArgs e)
        {
            if (SplineList.SelectedIndex == -1) return;
            if ((SplineList.Items.Count > 0) && (SplineList.SelectedIndex < Splines.Count))
            {
                int spi = SplineList.SelectedIndex;
                Splines.RemoveAt(spi);
                SplineList.Items.RemoveAt(spi);
            }
        }

        private void SplineList_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (SplineList.SelectedIndex == -1 || ViewAll.Checked)
            {
                SplineList.SelectedIndex = -1;
                return;
            }
            if ((SplineList.Items.Count > 0) && (SplineList.SelectedIndex < Splines.Count))
            {
                Nodes = (Point[])Splines[SplineList.SelectedIndex];
                NodeSelect = -1;
                DrawGraphics();
            }
        }

        private void Export_Click(object sender, EventArgs e)
        {
            if (Splines.Count > 0)
            {

                saveFileDialog1.InitialDirectory = Environment.GetFolderPath(System.Environment.SpecialFolder.Personal);
                saveFileDialog1.Filter = "Spline Files (.spf)|*.spf|All Files (*.*)|*.*";
                saveFileDialog1.FilterIndex = 1;
                saveFileDialog1.AddExtension = true;
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    string[] tmp = new string[SplineList.Items.Count];
                    SplineList.Items.CopyTo(tmp, 0);

                    var ser = new BinaryFormatter();
                    using (var stream = File.OpenWrite(saveFileDialog1.FileName))
                    {
                        ser.Serialize(stream, Splines);
                        ser.Serialize(stream, tmp);
                    }
                }
                DrawGraphics();
            }
        }

        private void Import_Click(object sender, EventArgs e)
        {

            openFileDialog1.InitialDirectory = Environment.GetFolderPath(System.Environment.SpecialFolder.Personal);
            openFileDialog1.FileName = "*.spf";
            openFileDialog1.Filter = "Spline Files (.spf)|*.spf|All Files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    var ser = new BinaryFormatter();
                    string[] tmp;
                    using (var stream = File.OpenRead(openFileDialog1.FileName))
                    {
                        Splines = (ArrayList)ser.Deserialize(stream);

                        tmp = (string[])ser.Deserialize(stream);
                    }
                    SplineList.Items.Clear();
                    for (int i = 0; i < Splines.Count; i++)
                    {
                        //SplineList.Items.Add("Spline" + i.ToString());
                        SplineList.Items.Add(tmp[i]);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Error: Could not read file from disk. Original error: " + ex.Message);
                }
            }
        }


        private void ApplyAll_Click(object sender, EventArgs e)
        {
           if (Splines.Count == 0) return;
           if (ViewAll.Checked) Splines =(ArrayList) cloneSplines.Clone();
           NodeSelect = -1;
           for (int i=0;i<Splines.Count;i++)
           {
               Nodes = (Point[])Splines[i];
               ApplyChanges();
           }
           Array.Resize(ref Nodes, 0);
           NodeSelect = -1;
           ViewAll.Checked = false;
           DrawGraphics();
        }



        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (SplineList.SelectedIndex > -1)
            {
                if (e.KeyChar==(char)Keys.Enter)
                {
                    if (SplineName.Text!="")SplineList.Items[SplineList.SelectedIndex]=SplineName.Text;
                }
            }
        }


        private void ColorPanel_Paint(object sender, PaintEventArgs e)
        {
            DrawGraphics();
        }

        private void PreViewBMP_Click(object sender, EventArgs e)
        {

        }

        private void RedoLines_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage(OverlayBMP);
            g.Clear(Color.Transparent);
            g.Dispose();
            SplineList.SelectedIndex = -1;
            DrawGraphics();
        }

        private void Clone_Click(object sender, EventArgs e)
        {
            if (SplineList.SelectedIndex == -1) return;
            NodeSelect = -1;
            Array.Resize(ref Nodes, 0);
            Point[] tmp = (Point[]) Splines[SplineList.SelectedIndex];
            Array.Resize(ref Nodes, tmp.Length);
            Array.Copy(tmp, Nodes, tmp.Length);
            SplineList.SelectedIndex=-1;
            DrawGraphics();
        }

        private void ViewAll_CheckedChanged(object sender, EventArgs e)
        {
            if (ViewAll.Checked) cloneSplines = (ArrayList)Splines.Clone();
            Reset_Click(sender, e);
            
        }

        private void EffectPluginConfigDialog_Resize(object sender, EventArgs e)
        {
            Control control = (Control)sender;
            this.WindowState = FormWindowState.Maximized;
            this.MinimumSize = control.Size;
            this.MaximumSize = control.Size;
            DrawGraphics();
        }



        protected override void WndProc(ref Message message)
        {
            const int WM_SYSCOMMAND = 0x0112;
            const int SC_MOVE = 0xF010;

            switch(message.Msg)
            {
            case WM_SYSCOMMAND:
            int command = message.WParam.ToInt32() & 0xfff0;
            if (command == SC_MOVE)
            return;
            break;
            }

            base.WndProc(ref message);
        }

        private void SaveXform_Click(object sender, EventArgs e)
        {
            if (Splines.Count == 0) return;
            if (ViewAll.Checked) Splines = (ArrayList)cloneSplines.Clone();
            NodeSelect = -1;
            Array.Resize(ref Nodes, 0);
            ViewAll.Checked = false;
            DrawGraphics();
        }

        private void Xparent_CheckedChanged(object sender, EventArgs e)
        {
            if (Xparent.Enabled) DrawGraphics();
        }

    }
}