using System;
using System.Drawing;
using PaintDotNet;

namespace TRsSplineMaster
{
    public class EffectPluginConfigToken : PaintDotNet.Effects.EffectConfigToken
    {
        // Declare variables here
        // Using getters/setters, you can manipulate the "value" before assigning it to your private variable.

        // Example using getters/setters:
        //----------------------------------------

        public bool Save
        {
            get;
            set;
        }

         public bool ShowHandles
        {
            get;
            set;
        }

        public int lineWidth
        {
            get;
            set;
        }
        public bool AntiAliasBox
        {
            get;
            set;
        }
        public int Tension
        {
            get;
            set;
        }
        public int Opaque
        {
            get;
            set;
        }
        public int SCap
        {
            get;
            set;
        }
        public int LStyle
        {
            get;
            set;
        }
        public int ECap
        {
            get;
            set;
        }
        public Color ColorPanel
        {
            get;
            set;
        }
        public Color SelectPanel
        {
            get;
            set;
        }
        public Color NodePanel
        {
            get;
            set;
        }
        public Color fillPanel
        {
            get;
            set;
        }

        public EffectPluginConfigToken(bool save, bool showhandles, int linewidth, 
            bool antialias, int tension, int opaque, int scap, int lstyle, int ecap, Color colorpan, Color selectpan,
            Color nodepan, Color fillpan)
            : base()
        {
            this.Save = save;
            this.ShowHandles = showhandles;
            this.lineWidth = linewidth;
            this.AntiAliasBox = antialias;
            this.Tension = tension;
            this.Opaque = opaque;
            this.SCap = scap;
            this.LStyle = lstyle;
            this.ECap = ecap;
            this.ColorPanel = colorpan;
            this.SelectPanel = selectpan;
            this.NodePanel = nodepan;
            this.fillPanel = fillpan;
        }

        protected EffectPluginConfigToken(EffectPluginConfigToken copyMe)
            : base(copyMe)
        {
            this.Save = copyMe.Save;
            this.ShowHandles = copyMe.ShowHandles;
            this.lineWidth = copyMe.lineWidth;
            this.AntiAliasBox = copyMe.AntiAliasBox;
            this.Tension = copyMe.Tension;
            this.Opaque = copyMe.Opaque;
            this.SCap = copyMe.SCap;
            this.LStyle = copyMe.LStyle;
            this.ECap = copyMe.ECap;
            this.ColorPanel = copyMe.ColorPanel;
            this.SelectPanel = copyMe.SelectPanel;
            this.NodePanel = copyMe.NodePanel;
            this.fillPanel = copyMe.fillPanel;
        }

        public override object Clone()
        {
            return new EffectPluginConfigToken(this);
        }
    }
}